/* 
 * File   : console_ffield_main.cpp
 * Version: 2008-06-06
 *
 * Copyright (C) 2008 Jochen Peters
 *
 * dev@emirp.net
 * http://www.emirp.net/
 * 
 * This file is part of FissionField and FissionField2x.
 *
 * FissionField(2x) is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * FissionField(2x) is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with FissionField(2x). If not, see <http://www.gnu.org/licenses/>.
 *
 */


#include <iostream>
#include "ffield.hpp"

using namespace ffield;

int main(int argc, char* argv[]) {
	
	int fieldSize = 5;
	if(argc > 1) {
		fieldSize = atol(argv[1]);
	}
	
	AtomicField* field = new AtomicField(fieldSize);

	while(1) {

		int row, col;
		enum color winner;

		/* RED's turn */
		field->printField();
		do {
			std::cout << "RED (row): ";
			std::cin >> row;
			row--;
			std::cout << "RED (col): ";
			std::cin >> col;
			col--;
		} while(!field->makeMove(row, col, RED));

		std::cout << "\n";

		winner = field->checkForWinner();
		if(winner == RED) {
			field->printField();
			std::cout << "\n!!! RED WINS !!!\n\n";
			break;
		}
		else if(winner == BLUE) {
			field->printField();
			std::cout << "\n!!! BLUE WINS !!!\n\n";
			break;
		}

		/* BLUES's turn */
		field->printField();
		do {
			std::cout << "BLUE (row): ";
			std::cin >> row;
			row--;
			std::cout << "BLUE (col): ";
			std::cin >> col;
			col--;
		} while(!field->makeMove(row, col, BLUE));

		std::cout << "\n";

		winner = field->checkForWinner();
		if(winner == RED) {
			field->printField();
			std::cout << "\n!!! RED WINS !!!\n\n";
			break;
		}
		else if(winner == BLUE) {
			field->printField();
			std::cout << "\n!!! BLUE WINS !!!\n\n";
			break;
		}

	}

	return 0;

}

