/* 
 * File   : sdl_ffield.hpp
 * Version: 2008-06-06
 *
 * Copyright (C) 2008 Jochen Peters
 *
 * dev@emirp.net
 * http://www.emirp.net/
 * 
 * This file is part of FissionField and FissionField2x.
 *
 * FissionField(2x) is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * FissionField(2x) is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with FissionField(2x). If not, see <http://www.gnu.org/licenses/>.
 *
 */


#ifndef SDL_ATOMVS
#define SDL_ATOMVS

#include <SDL/SDL.h>
//#include <SDL/SDL_audio.h>
#include <SDL/SDL_mixer.h>
#include "ffield.hpp"

using namespace ffield;

/* Timing */
#define DEFAULT_DELAY_TIME 15


/*
typedef struct {
	Uint8* data;
	Uint32 pos;
	Uint32 len;
} SoundData;
*/

/* Global variables */
extern SDL_Surface* screen;
extern	int soundVolume;
//extern SoundData soundToPlay;

//void mixAudio(void* unused, Uint8* stream, int len); // Callback function for SDL_AudioSpec

class sdlAtomicField : public AtomicField {

	public:
		sdlAtomicField(int size, Uint8 xpos, Uint8 ypos, bool sound);
		~sdlAtomicField();

		int getRow(int posY) const;
		int getCol(int posX) const;
		int getPosX(int col) const;
		int getPosY(int row) const;

		void updateField(int row, int col);
		void updateField();

		Mix_Chunk* clickSound;

	protected:
		virtual void addUpdate(int row, int col);
		virtual void explodeUpdate(int row, int col, enum color team, int phase);

	private:
		Uint8 ulCornerX;
		Uint8 ulCornerY;
		SDL_Surface* atomBitmaps[9];
		SDL_Rect image_rect; // blitting rectangle
		bool playSound;
		//SoundData clickSound;

};

class sdlFieldCursor {
	
	public:
		sdlFieldCursor(const sdlAtomicField* field);
		void moveTo(int row, int col);
		void moveRight();
		void moveDown();
		void moveLeft();
		void moveUp();
		void setVisible(bool seton);
		int getRow() const;
		int getCol() const;

	private:
		const sdlAtomicField* field;
		int posRow;
		int posCol;
		bool visible;
		SDL_Surface* activeFrame;
		SDL_Surface* inactiveFrame;
		SDL_Rect image_rect; // blitting rectangle

};

#endif

